How to apply canvas animations with Vue and Konva?
Konva provides two methods for animations: Tween and Animation. For simple use cases, we recommend using the node.to() method, which is a simplified version of Tween.
Instructions: Try to drag the green rectangle to see it scale randomly, and observe the red hexagon moving in a sine wave pattern.
<template>
<v-stage ref="stage" :config="stageSize">
<v-layer ref="layer">
<v-rect
ref="rect"
@dragstart="changeSize"
@dragend="changeSize"
:config="{
width: 50,
height: 50,
fill: 'green',
draggable: true,
x: 100,
y: 100
}"
/>
<v-regular-polygon
ref="hexagon"
:config="{
x: 200,
y: 200,
sides: 6,
radius: 20,
fill: 'red',
stroke: 'black',
strokeWidth: 4
}"
/>
</v-layer>
</v-stage>
</template>
<script setup>
import { ref, onMounted } from 'vue';
import Konva from 'konva';
const stageSize = {
width: window.innerWidth,
height: window.innerHeight
};
const stage = ref(null);
const hexagon = ref(null);
const changeSize = (e) => {
// to() is a method of `Konva.Node` instances
e.target.to({
scaleX: Math.random() + 0.8,
scaleY: Math.random() + 0.8,
duration: 0.2
});
};
onMounted(() => {
const amplitude = 100;
const period = 5000; // in ms
const centerX = stage.value.getNode().getWidth() / 2;
const hexagonNode = hexagon.value.getNode();
// example of Konva.Animation
const anim = new Konva.Animation((frame) => {
hexagonNode.setX(
amplitude * Math.sin((frame.time * 2 * Math.PI) / period) + centerX
);
}, hexagonNode.getLayer());
anim.start();
});
</script>
The demo above shows two types of animations:
- Using
node.to()method (Tween) to animate the green rectangle's scale when dragged - Using
Konva.Animationto create a continuous sine wave movement for the red hexagon
The node.to() method is perfect for simple transitions, while Konva.Animation is better for complex, continuous animations that need to run on each frame.

Skip to main content

Angular Konva Simple Animations Tutorial

To create simple animations with Konva in Angular, you can use the ng2-konva library with the Animation component or manual animation loops.

For full list of properties and methods, see the Konva API Reference.

Simple Animation Example

import { Component, ViewChild, OnInit, OnDestroy } from '@angular/core';
import { StageConfig } from 'konva/lib/Stage';
import { CircleConfig } from 'konva/lib/shapes/Circle';
import * as Konva from 'konva';

import {
  CoreShapeComponent,
  StageComponent,
} from 'ng2-konva';

@Component({
  selector: 'app-root',
  template: `
    <ko-stage [config]="configStage">
      <ko-layer>
        <ko-circle #circle [config]="configCircle"></ko-circle>
      </ko-layer>
    </ko-stage>
  `,
  imports: [StageComponent, CoreShapeComponent],
})
export default class App implements OnInit, OnDestroy {
  @ViewChild('circle') circle!: any;
  private animation: any = null;

  public configStage: StageConfig = {
    width: window.innerWidth,
    height: window.innerHeight,
  };
  public configCircle: CircleConfig = {
    x: 100,
    y: 100,
    radius: 50,
    fill: 'red',
    stroke: 'black',
    strokeWidth: 4
  };

  ngAfterViewInit() {
    const circle = this.circle.getNode();
    this.animation = new Konva.Animation((frame: any) => {
      const time = frame.time;
      const x = 100 + Math.sin(time / 1000) * 100;
      circle.x(x);
    }, circle.getLayer());

    this.animation.start();
  }

  ngOnDestroy() {
    if (this.animation) {
      this.animation.stop();
    }
  }
}

Skip to main content

How to apply canvas animations with React and Konva?

Konva itself has two methods for animations: Tween and Animation. You can apply both of them to nodes manually.

For simple use cases we recommend using the node.to() method. For more complex animations take a look at the Complex react-konva animation demo.

The demo is using the refs API to access shape instances directly.

Instructions: Try to drag the rectangle to see it animate.

import React, { useRef } from 'react';
import { Stage, Layer, Rect } from 'react-konva';

const MyRect = () => {
  const rectRef = useRef(null);

  const changeSize = () => {
    // to() is a method of `Konva.Node` instances
    rectRef.current.to({
      scaleX: Math.random() + 0.8,
      scaleY: Math.random() + 0.8,
      duration: 0.2,
    });
  };

  return (
    <Rect
      ref={rectRef}
      width={50}
      height={50}
      fill="green"
      draggable
      onDragEnd={changeSize}
      onDragStart={changeSize}
    />
  );
};

const App = () => {
  return (
    <Stage width={window.innerWidth} height={window.innerHeight}>
      <Layer>
        <MyRect />
      </Layer>
    </Stage>
  );
};

export default App;